<?php

class car{
    private static $car = array();
    
    function __construct($plate){
        $this->setCar(str_replace(" ","",$plate));
    }
    
    function __destruct(){        
        echo "Class Object <b>". get_class($this) ." - plate: ". (string)self::$car["plate"] ."</b> is destroyed!!!<br />";
    }
    
    function __toString(){
        echo "<br />";
        $res = "";
        foreach(self::$car as $key=>$val){
            if ($key === "tank"){   $res .= "tank: ".$val["full"]." - ".$val["now"];    }
            else{   $res .= "$key: $val<br />"; }
        }
        return $res;
    }
    
    public function setCar($plate){
        self::$car["plate"] = $plate;
    }
    
    public static function setInfo($assoc_arr){
        if( sizeof($assoc_arr) >= 1){
            foreach($assoc_arr as $key=>$val){
                self::$car[$key] = $val;
            }
        }
    }
    
    public static function setInfo_manual($key, $val){
        self::$car[$key] = $val;
    }
    
    public static function getCar(){
        var_dump(self::$car);
    }
}




///STATIC
$plate = "C 0345CC";
$year = "2014";
$manufacturer = "BMW";
$model = "E92";
$type = "coupe";
$fuel = "gas";
$HP = "320";
$color = "red";


///DYNAMIC
$km = "10000";
$tyres = "winter";
$tank = array("full"=>62, "now"=>30);




$car = new car($plate);

$car_info_static = array("year"=>$year, "manufacturer"=>$manufacturer, "model"=>$model, "type"=>$type, "fuel"=>$fuel ,"HP"=>$HP,"color"=>$color);

$car_info_dynamic = array("km"=>$km, "tyres"=>$tyres, "tank"=>$tank);

$car::setInfo($car_info_static);
$car::setInfo($car_info_dynamic);

echo $car."<br />";
echo "<br /><br />MANUAL SET THE km<br />";
$car::setInfo_manual("km","10050");

echo $car."<br />";

$car::getCar();

echo '<br /><br />If you want to see the code go to <b>"location to your htdocs/softuni"</b> folder and open  <b>"classCar.php"</b><br />';

///return: Hello World!!!<br />This is an class CAR function! 